Index: LMDZ6/branches/IPSL-CM6A-MR/DefLists/file_def_histday_lmdz.xml
===================================================================
--- LMDZ6/branches/IPSL-CM6A-MR/DefLists/file_def_histday_lmdz.xml	(revision 3807)
+++ LMDZ6/branches/IPSL-CM6A-MR/DefLists/file_def_histday_lmdz.xml	(revision 3854)
@@ -451,6 +451,4 @@
                 <field field_ref="cldemi" level="5" />
                 <field field_ref="tke_max" level="10" operation="maximum" />
-                <field field_ref="kz" level="10" />
-                <field field_ref="kz_max" level="10" operation="maximum" />
                 <field field_ref="concso4" level="6" />
                 <field field_ref="concoa" level="6" />
@@ -529,5 +527,4 @@
                 <field field_ref="wdtrainA" level="1" />
                 <field field_ref="wdtrainM" level="1" />
-                <field field_ref="Vprecip" level="10" />
                 <field field_ref="ftd" level="5" />
                 <field field_ref="fqd" level="5" />
@@ -553,10 +550,7 @@
                 <field field_ref="ratqs" level="10" />
                 <field field_ref="dtthe" level="10" />
-                <field field_ref="f_th" level="10" />
                 <field field_ref="e_th" level="10" />
-                <field field_ref="w_th" level="10" />
                 <field field_ref="lambda_th" level="10" />
                 <field field_ref="q_th" level="10" />
-                <field field_ref="a_th" level="10" />
                 <field field_ref="s_th" level="10" />
                 <field field_ref="s_env" level="10" />
@@ -587,12 +581,4 @@
                 <field field_ref="dtlif" level="10" />
                 <field field_ref="dthin" level="10" />
-                <field field_ref="rsu" level="10" />
-                <field field_ref="rsd" level="10" />
-                <field field_ref="rlu" level="10" />
-                <field field_ref="rld" level="10" />
-                <field field_ref="rsucs" level="10" />
-                <field field_ref="rsdcs" level="10" />
-                <field field_ref="rlucs" level="10" />
-                <field field_ref="rldcs" level="10" />
                 <field field_ref="tnt" level="10" />
                 <field field_ref="tntc" level="10" />
@@ -602,5 +588,4 @@
                 <field field_ref="tnhusc" level="10" />
                 <field field_ref="tnhusscpbl" level="10" />
-                <field field_ref="evu" level="10" />
                 <field field_ref="h2o" level="10" />
                 <field field_ref="mcd" level="10" />
@@ -608,12 +593,4 @@
                 <field field_ref="ref_liq" level="10" />
                 <field field_ref="ref_ice" level="10" />
-                <field field_ref="rsu4co2" level="10" />
-                <field field_ref="rlu4co2" level="10" />
-                <field field_ref="rsucs4co2" level="10" />
-                <field field_ref="rlucs4co2" level="10" />
-                <field field_ref="rsd4co2" level="10" />
-                <field field_ref="rld4co2" level="10" />
-                <field field_ref="rsdcs4co2" level="10" />
-                <field field_ref="rldcs4co2" level="10" />
                 <field field_ref="treedrg_ter" level="6" />
                 <field field_ref="treedrg_lic" level="6" />
@@ -639,4 +616,29 @@
                 <field field_ref="ozone_daylight" level="10" />
             </field_group>
+            <field_group operation="average" grid_ref="grid_out_presinter">
+                <field field_ref="a_th" level="9" />
+                <field field_ref="f_th" level="7" />
+                <field field_ref="w_th" level="7" />
+                <field field_ref="rsucs" level="10" />
+                <field field_ref="rsdcs" level="10" />
+                <field field_ref="rlucs" level="10" />
+                <field field_ref="rldcs" level="10" />
+                <field field_ref="rldcs4co2" level="10" />
+                <field field_ref="rlucs4co2" level="10" />
+                <field field_ref="rsdcs4co2" level="10" />
+                <field field_ref="rsucs4co2" level="10" />
+                <field field_ref="rsu4co2" level="10" />
+                <field field_ref="rlu4co2" level="10" />
+                <field field_ref="rsd4co2" level="10" />
+                <field field_ref="rld4co2" level="10" />
+                <field field_ref="Vprecip" level="11" />
+                <field field_ref="rsu" level="5" />
+                <field field_ref="rsd" level="5" />
+                <field field_ref="rlu" level="5" />
+                <field field_ref="rld" level="5" />
+                <field field_ref="kz" level="4" />
+                <field field_ref="kz_max" level="4" operation="maximum" />
+                <field field_ref="evu" level="10" />
+            </field_group>
             
           </field_group>