Index: LMDZ6/trunk/libf/phylmd/calcratqs.F90
===================================================================
--- LMDZ6/trunk/libf/phylmd/calcratqs.F90	(revision 3845)
+++ LMDZ6/trunk/libf/phylmd/calcratqs.F90	(revision 3856)
@@ -2,8 +2,8 @@
            iflag_ratqs,iflag_con,iflag_cld_th,pdtphys, &
            ratqsbas,ratqshaut,ratqsp0,ratqsdp, &
-           tau_ratqs,fact_cldcon,   &
+           tau_ratqs,fact_cldcon,wake_s, wake_deltaq,   &
            ptconv,ptconvth,clwcon0th, rnebcon0th,      &
            paprs,pplay,q_seri,zqsat,fm_therm,          &
-           ratqs,ratqsc)
+           ratqs,ratqsc,ratqs_inter)
 
 implicit none
@@ -27,7 +27,7 @@
 logical, dimension(klon,klev),intent(in) :: ptconv
 real, dimension(klon,klev),intent(in) :: rnebcon0th,clwcon0th
-
+real, dimension(klon,klev),intent(in) :: wake_deltaq,wake_s
 ! Output
-real, dimension(klon,klev),intent(inout) :: ratqs,ratqsc
+real, dimension(klon,klev),intent(inout) :: ratqs,ratqsc,ratqs_inter
 logical, dimension(klon,klev),intent(inout) :: ptconvth
 
@@ -124,5 +124,5 @@
          enddo
 
-      else if (iflag_ratqs==4) then
+      else if (iflag_ratqs==4) then 
          do k=1,klev
            ratqss(:,k)=ratqsbas+0.5*(ratqshaut-ratqsbas) &
@@ -131,7 +131,14 @@
          enddo
 
+      else if (iflag_ratqs==10) then ! ratqs interactif dépendant de la présence de poches froides
+         call calcratqs_inter(klon,klev,pdtphys,ratqsbas,wake_deltaq,wake_s,q_seri,ratqs_inter)
+         do k=1,klev
+            do i=1, klon
+                ratqss(i,k)=ratqs_inter(i,k)+0.5*(ratqshaut-ratqs_inter(i,k)) &
+                *( tanh( (ratqsp0-pplay(i,k))/ratqsdp) + 1.)
+            enddo
+         enddo
+
       endif
-
-
 
 
Index: LMDZ6/trunk/libf/phylmd/phyetat0.F90
===================================================================
--- LMDZ6/trunk/libf/phylmd/phyetat0.F90	(revision 3845)
+++ LMDZ6/trunk/libf/phylmd/phyetat0.F90	(revision 3856)
@@ -19,5 +19,5 @@
        wake_s, wake_dens, zgam, zmax0, zmea, zpic, zsig, &
        zstd, zthe, zval, ale_bl, ale_bl_trig, alp_bl, u10m, v10m, treedrg, &
-       ale_wake, ale_bl_stat, ds_ns, dt_ns, delta_sst, delta_sal
+       ale_wake, ale_bl_stat, ds_ns, dt_ns, delta_sst, delta_sal, ratqs_inter
 !FC
   USE geometry_mod, ONLY : longitude_deg, latitude_deg
@@ -435,4 +435,7 @@
   found=phyetat0_get(1,ale_bl_stat,"ALE_BL_STAT","ALE_BL_STAT",0.)
 
+! fisrtilp/Clouds
+  found=phyetat0_get(klev,ratqs_inter,"RATQS_INTER","Relative width of the lsc sugrid scale water",ratqs_inter)
+
 !===========================================
   ! Read and send field trs to traclmdz
Index: LMDZ6/trunk/libf/phylmd/phyredem.F90
===================================================================
--- LMDZ6/trunk/libf/phylmd/phyredem.F90	(revision 3845)
+++ LMDZ6/trunk/libf/phylmd/phyredem.F90	(revision 3856)
@@ -28,5 +28,5 @@
                                 du_gwd_rando, du_gwd_front, u10m, v10m, &
                                 treedrg, solswfdiff, delta_sal, ds_ns, dt_ns, &
-                                delta_sst
+                                delta_sst, ratqs_inter
 
   USE geometry_mod, ONLY : longitude_deg, latitude_deg
@@ -303,4 +303,8 @@
 
     CALL put_field(pass,"ALE_BL_STAT", "ALE_BL_STAT", ale_bl_stat)
+
+
+    ! fisrtilp/clouds
+    CALL put_field(pass,"RATQS_INTER","Relative width of the lsc sugrid scale water",ratqs_inter)
 
 
Index: LMDZ6/trunk/libf/phylmd/phys_state_var_mod.F90
===================================================================
--- LMDZ6/trunk/libf/phylmd/phys_state_var_mod.F90	(revision 3845)
+++ LMDZ6/trunk/libf/phylmd/phys_state_var_mod.F90	(revision 3856)
@@ -418,8 +418,9 @@
 !$OMP THREADPRIVATE(ccm)
 
-!!! nrlmd le 10/04/2012
       REAL,SAVE,ALLOCATABLE :: ale_bl_trig(:)
 !$OMP THREADPRIVATE(ale_bl_trig)
-!!! fin nrlmd le 10/04/2012
+
+      REAL,SAVE,ALLOCATABLE :: ratqs_inter(:,:)
+!$OMP THREADPRIVATE(ratqs_inter)
 
       REAL, ALLOCATABLE, SAVE:: du_gwd_rando(:, :), du_gwd_front(:, :)
@@ -648,8 +649,6 @@
       ALLOCATE(cg_aero_lw_rrtm(klon,klev,2,nbands_lw_rrtm))
       ALLOCATE(ccm(klon,klev,nbands))
-
-!!! nrlmd le 10/04/2012
       ALLOCATE(ale_bl_trig(klon))
-!!! fin nrlmd le 10/04/2012
+      ALLOCATE(ratqs_inter(klon,klev))
       IF (ok_gwd_rando) THEN
         ALLOCATE(du_gwd_rando(klon, klev))
@@ -794,8 +793,6 @@
       if (ok_gwd_rando) DEALLOCATE(du_gwd_rando)
       if (.not. ok_hines .and. ok_gwd_rando) DEALLOCATE(du_gwd_front)
-       
-!!! nrlmd le 10/04/2012
       DEALLOCATE(ale_bl_trig)
-!!! fin nrlmd le 10/04/2012
+      DEALLOCATE(ratqs_inter)
 
       if (activate_ocean_skin >= 1) deALLOCATE(delta_sal, ds_ns, dt_ns, &
Index: LMDZ6/trunk/libf/phylmd/physiq_mod.F90
===================================================================
--- LMDZ6/trunk/libf/phylmd/physiq_mod.F90	(revision 3845)
+++ LMDZ6/trunk/libf/phylmd/physiq_mod.F90	(revision 3856)
@@ -3447,9 +3447,8 @@
          iflag_ratqs,iflag_con,iflag_cld_th,pdtphys,  &
          ratqsbas,ratqshaut,ratqsp0, ratqsdp, &
-         tau_ratqs,fact_cldcon,   &
+         tau_ratqs,fact_cldcon,wake_s, wake_deltaq,   &
          ptconv,ptconvth,clwcon0th, rnebcon0th,     &
          paprs,pplay,q_seri,zqsat,fm_therm, &
-         ratqs,ratqsc)
-
+         ratqs,ratqsc,ratqs_inter)
 
     !