Index: /LMDZ6/trunk/libf/phylmd/carbon_cycle_mod.F90
===================================================================
--- /LMDZ6/trunk/libf/phylmd/carbon_cycle_mod.F90	(revision 3875)
+++ /LMDZ6/trunk/libf/phylmd/carbon_cycle_mod.F90	(revision 3876)
@@ -45,13 +45,13 @@
   LOGICAL, PUBLIC :: read_fco2_ocean_cor    ! flag to read corrective oceanic CO2 flux
 !$OMP THREADPRIVATE(read_fco2_ocean_cor)  
-  REAL, SAVE, PUBLIC :: var_fco2_ocean_cor        ! corrective oceanic CO2 flux
+  REAL, PUBLIC :: var_fco2_ocean_cor        ! corrective oceanic CO2 flux
 !$OMP THREADPRIVATE(var_fco2_ocean_cor)
-  REAL, SAVE, PUBLIC :: ocean_area_tot            ! total oceanic area to convert flux
+  REAL, PUBLIC :: ocean_area_tot            ! total oceanic area to convert flux
 !$OMP THREADPRIVATE(ocean_area_tot)
   LOGICAL, PUBLIC :: read_fco2_land_cor     ! flag to read corrective land CO2 flux
 !$OMP THREADPRIVATE(read_fco2_land_cor)  
-  REAL, SAVE, PUBLIC :: var_fco2_land_cor         ! corrective land CO2 flux
+  REAL, PUBLIC :: var_fco2_land_cor         ! corrective land CO2 flux
 !$OMP THREADPRIVATE(var_fco2_land_cor)
-  REAL, SAVE, PUBLIC :: land_area_tot             ! total land area to convert flux
+  REAL, PUBLIC :: land_area_tot             ! total land area to convert flux
 !$OMP THREADPRIVATE(land_area_tot)
 
@@ -108,7 +108,7 @@
   REAL, DIMENSION(:), ALLOCATABLE, PUBLIC :: fco2_ocean ! Net flux from ocean [kgCO2/m2/s]
 !$OMP THREADPRIVATE(fco2_ocean)
-  REAL, DIMENSION(:), ALLOCATABLE, SAVE, PUBLIC :: fco2_ocean_cor ! Net corrective flux from ocean [kgCO2/m2/s]
+  REAL, DIMENSION(:), ALLOCATABLE, PUBLIC :: fco2_ocean_cor ! Net corrective flux from ocean [kgCO2/m2/s]
 !$OMP THREADPRIVATE(fco2_ocean_cor)
-  REAL, DIMENSION(:), ALLOCATABLE, SAVE, PUBLIC :: fco2_land_cor  ! Net corrective flux from land [kgCO2/m2/s]
+  REAL, DIMENSION(:), ALLOCATABLE, PUBLIC :: fco2_land_cor  ! Net corrective flux from land [kgCO2/m2/s]
 !$OMP THREADPRIVATE(fco2_land_cor)
 
@@ -123,5 +123,5 @@
 
 ! Calculated co2 field to be send to the ocean via the coupler and to ORCHIDEE 
-  REAL, DIMENSION(:), ALLOCATABLE, SAVE, PUBLIC :: co2_send ! Field allocated in phyetat0
+  REAL, DIMENSION(:), ALLOCATABLE, PUBLIC :: co2_send ! Field allocated in phyetat0
 !$OMP THREADPRIVATE(co2_send)
 
Index: /LMDZ6/trunk/libf/phylmd/conf_phys_m.F90
===================================================================
--- /LMDZ6/trunk/libf/phylmd/conf_phys_m.F90	(revision 3875)
+++ /LMDZ6/trunk/libf/phylmd/conf_phys_m.F90	(revision 3876)
@@ -378,8 +378,6 @@
     !Config Desc = activation of output ascii file in inlandsis
     !Config Def  = 1
-   ok_outfor_omp = .FALSE.
+    ok_outfor_omp = .FALSE.
     CALL getin('ok_outfor', ok_outfor_omp)
-
-
 
     !==================================================================
@@ -1142,7 +1140,4 @@
     CALL getin('coefw_cld_cv',coefw_cld_cv_omp)
 
-
-
-
     !
     !Config Key  = iflag_pdf 
@@ -1153,4 +1148,5 @@
     iflag_pdf_omp = 0
     CALL getin('iflag_pdf',iflag_pdf_omp)
+
     !
     !Config Key  = fact_cldcon
@@ -1179,4 +1175,5 @@
     ok_newmicro_omp = .TRUE.
     CALL getin('ok_newmicro',ok_newmicro_omp)
+
     !
     !Config Key  = ratqsbas
@@ -1187,4 +1184,5 @@
     ratqsbas_omp = 0.01
     CALL getin('ratqsbas',ratqsbas_omp)
+
     !
     !Config Key  = ratqshaut
Index: /LMDZ6/trunk/libf/phylmd/pbl_surface_mod.F90
===================================================================
--- /LMDZ6/trunk/libf/phylmd/pbl_surface_mod.F90	(revision 3875)
+++ /LMDZ6/trunk/libf/phylmd/pbl_surface_mod.F90	(revision 3876)
@@ -46,5 +46,5 @@
   INTEGER, SAVE :: iflag_pbl_surface_t2m_bug
   !$OMP THREADPRIVATE(iflag_pbl_surface_t2m_bug)
-  integer, save :: iflag_new_t2mq2m
+  INTEGER, SAVE :: iflag_new_t2mq2m
   !$OMP THREADPRIVATE(iflag_new_t2mq2m)
 
@@ -148,4 +148,5 @@
     iflag_pbl_surface_t2m_bug=0
     CALL getin_p('iflag_pbl_surface_t2m_bug',iflag_pbl_surface_t2m_bug)
+    WRITE(lunout,*) 'iflag_pbl_surface_t2m_bug=',iflag_pbl_surface_t2m_bug
 !FC
 !    iflag_frein = 0
@@ -841,5 +842,5 @@
     ! Martin
 
-    real, DIMENSION(klon):: ydelta_sst, ydelta_sal, yds_ns, ydt_ns, ydter, ydser, &
+    REAL, DIMENSION(klon):: ydelta_sst, ydelta_sal, yds_ns, ydt_ns, ydter, ydser, &
          ytkt, ytks, ytaur, ysss
     ! compression of delta_sst, delta_sal, ds_ns, dt_ns, dter, dser, tkt, tks,
@@ -865,5 +866,5 @@
        iflag_new_t2mq2m=1
        CALL getin_p('iflag_new_t2mq2m',iflag_new_t2mq2m)
-       print*,'pbl_iflag_new_t2mq2m=',iflag_new_t2mq2m
+       WRITE(lunout,*) 'pbl_iflag_new_t2mq2m=',iflag_new_t2mq2m
 
        print*,'PBL SURFACE AVEC GUSTINESS'
@@ -871,6 +872,6 @@
       
        ! Initialize ok_flux_surf (for 1D model)
-       if (klon_glo>1) ok_flux_surf=.FALSE.
-       if (klon_glo>1) ok_forc_tsurf=.FALSE.
+       IF (klon_glo>1) ok_flux_surf=.FALSE.
+       IF (klon_glo>1) ok_forc_tsurf=.FALSE.
 
        ! intialize beta_land