Index: BOL/Multi_atlas/METRICS/metrics.sh
===================================================================
--- BOL/Multi_atlas/METRICS/metrics.sh	(revision 3785)
+++ BOL/Multi_atlas/METRICS/metrics.sh	(revision 3881)
@@ -5,8 +5,8 @@
 hostname=`hostname`
 if [ ${hostname:0:5} = cicla ] ; then
-DODSDIR=/prodigfs/ipslfs/dods
+DODSDIR=/thredds/ipsl
 fi
 if [ ${hostname:0:5} = camel ] ; then
-DODSDIR=/prodigfs/ipslfs/dods
+DODSDIR=/thredds/ipsl
 fi
 if [ ${hostname:0:5} = irene ] ; then
Index: BOL/Multi_atlas/html_1D.sh
===================================================================
--- BOL/Multi_atlas/html_1D.sh	(revision 3785)
+++ BOL/Multi_atlas/html_1D.sh	(revision 3881)
@@ -7,10 +7,10 @@
 hostname=`hostname`
 if [ ${hostname:0:5} = cicla ] ; then
-DODSDIR=/prodigfs/ipslfs/dods
+DODSDIR=/thredds/ipsl
 HTML00=http://vesg.ipsl.upmc.fr/thredds/fileServer/IPSLFS/$login
 machine=ciclad
 fi
 if [ ${hostname:0:5} = camel ] ; then
-DODSDIR=/prodigfs/ipslfs/dods
+DODSDIR=/thredds/ipsl
 fi
 if [ ${hostname:0:5} = irene ] ; then
Index: BOL/Multi_atlas/html_entete.sh
===================================================================
--- BOL/Multi_atlas/html_entete.sh	(revision 3785)
+++ BOL/Multi_atlas/html_entete.sh	(revision 3881)
@@ -8,10 +8,10 @@
 hostname=`hostname`
 if [ ${hostname:0:5} = cicla ] ; then
-DODSDIR=/modfs/ipslfs/dods
+DODSDIR=/thredds/ipsl
 HTML00=http://vesg.ipsl.upmc.fr/thredds/fileServer/IPSLFS/$login
 machine=ciclad
 fi
 if [ ${hostname:0:5} = camel ] ; then
-DODSDIR=/modfs/ipslfs/dods
+DODSDIR=/thredds/ipsl
 fi
 if [ ${hostname:0:5} = irene ] ; then
Index: BOL/Multi_atlas/html_lma.sh
===================================================================
--- BOL/Multi_atlas/html_lma.sh	(revision 3785)
+++ BOL/Multi_atlas/html_lma.sh	(revision 3881)
@@ -7,10 +7,10 @@
 hostname=`hostname`
 if [ ${hostname:0:5} = cicla ] ; then
-DODSDIR=/prodigfs/ipslfs/dods
+DODSDIR=/thredds/ipsl
 HTML00=http://vesg.ipsl.upmc.fr/thredds/fileServer/IPSLFS/$login
 machine=ciclad
 fi
 if [ ${hostname:0:5} = camel ] ; then
-DODSDIR=/prodigfs/ipslfs/dods
+DODSDIR=/thredds/ipsl
 fi
 if [ ${hostname:0:5} = irene ] ; then
Index: BOL/Multi_atlas/html_pcmdi.sh
===================================================================
--- BOL/Multi_atlas/html_pcmdi.sh	(revision 3785)
+++ BOL/Multi_atlas/html_pcmdi.sh	(revision 3881)
@@ -5,10 +5,10 @@
 hostname=`hostname`
 if [ ${hostname:0:5} = cicla ] ; then
-DODSDIR=/prodigfs/ipslfs/dods
+DODSDIR=/thredds/ipsl
 HTML00=http://vesg.ipsl.upmc.fr/thredds/fileServer/IPSLFS/$login
 machine=ciclad
 fi
 if [ ${hostname:0:5} = camel ] ; then
-DODSDIR=/prodigfs/ipslfs/dods
+DODSDIR=/thredds/ipsl
 fi
 if [ ${hostname:0:5} = irene ] ; then
Index: BOL/Multi_atlas/html_tuning.sh
===================================================================
--- BOL/Multi_atlas/html_tuning.sh	(revision 3785)
+++ BOL/Multi_atlas/html_tuning.sh	(revision 3881)
@@ -7,10 +7,10 @@
 hostname=`hostname`
 if [ ${hostname:0:5} = cicla ] ; then
-DODSDIR=/modfs/ipslfs/dods
+DODSDIR=/thredds/ipsl
 HTML00=http://vesg.ipsl.upmc.fr/thredds/fileServer/IPSLFS/$login
 machine=ciclad
 fi
 if [ ${hostname:0:5} = camel ] ; then
-DODSDIR=/modfs/ipslfs/dods
+DODSDIR=/thredds/ipsl
 fi
 if [ ${hostname:0:5} = irene ] ; then
Index: BOL/Multi_atlas/html_tuning_min.sh
===================================================================
--- BOL/Multi_atlas/html_tuning_min.sh	(revision 3785)
+++ BOL/Multi_atlas/html_tuning_min.sh	(revision 3881)
@@ -7,10 +7,10 @@
 hostname=`hostname`
 if [ ${hostname:0:5} = cicla ] ; then
-DODSDIR=/modfs/ipslfs/dods
+DODSDIR=/thredds/ipsl
 HTML00=http://vesg.ipsl.upmc.fr/thredds/fileServer/IPSLFS/$login
 machine=ciclad
 fi
 if [ ${hostname:0:5} = camel ] ; then
-DODSDIR=/modfs/ipslfs/dods
+DODSDIR=/thredds/ipsl
 fi
 if [ ${hostname:0:5} = irene ] ; then
Index: BOL/Multi_atlas/make_MOY.sh
===================================================================
--- BOL/Multi_atlas/make_MOY.sh	(revision 3785)
+++ BOL/Multi_atlas/make_MOY.sh	(revision 3881)
@@ -22,10 +22,10 @@
 hostname=`hostname`
 if [ ${hostname:0:5} = cicla ] ; then
-DODSDIR=/modfs/ipslfs/dods
+DODSDIR=/thredds/ipsl
 OBSDIR=$DODSDIR/fabric/lmdz
 ferret="/opt/ferret-7.0.0/bin/ferret"
 fi
 if [ ${hostname:0:5} = camel ] ; then
-DODSDIR=/modfs/ipslfs/dods
+DODSDIR=/thredds/ipsl
 OBSDIR=$DODSDIR/$login/lmdz
 ferret="/opt/ferret-7.0.0/bin/ferret"
Index: BOL/Multi_atlas/multi_atlas.sh
===================================================================
--- BOL/Multi_atlas/multi_atlas.sh	(revision 3785)
+++ BOL/Multi_atlas/multi_atlas.sh	(revision 3881)
@@ -21,9 +21,9 @@
 hostname=`hostname`
 if [ ${hostname:0:5} = cicla ] ; then
-DODSDIR=/modfs/ipslfs/dods
+DODSDIR=/thredds/ipsl
 HTML=http://vesg.ipsl.upmc.fr/thredds/fileServer/IPSLFS/$login/lmdz/MultiSimu/$comp
 fi
 if [ ${hostname:0:5} = camel ] ; then
-DODSDIR=/modfs/ipslfs/dods
+DODSDIR=/thredds/ipsl
 fi
 if [ ${hostname:0:5} = irene ] ; then