Index: /BOL/Multi_atlas/cmor.sh
===================================================================
--- /BOL/Multi_atlas/cmor.sh	(revision 3881)
+++ /BOL/Multi_atlas/cmor.sh	(revision 3882)
@@ -2,4 +2,7 @@
 
 #set -vx
+
+local=`pwd -P`
+cd $local
 
 ####################################################################
@@ -16,9 +19,9 @@
 hostname=`hostname`
 if [ ${hostname:0:5} = cicla ] ; then
-DODSDIR=/modfs/ipslfs/dods
+DODSDIR=/thredds/ipsl
 OBSDIR=$DODSDIR/fabric/lmdz/SE/CMOR/OBS
 fi
 if [ ${hostname:0:5} = camel ] ; then
-DODSDIR=/modfs/ipslfs/dods
+DODSDIR=/thredds/ipsl
 OBSDIR=$DODSDIR/fabric/lmdz/SE/CMOR/OBS
 fi
@@ -32,5 +35,5 @@
 fi
 
-runstxt=/home/fabric/LMDZ/multi/runs.txt
+runstxt=${local}/runs.txt
 while test -n "${1}"; do
    case $1 in
@@ -93,10 +96,13 @@
   if [ ! -f $file ] ; then
       echo PB fichier $file inexistant
-      exit 22
-  else
+    file=$INDIR/${simorig}_SE_${years}_1M_histmth.nc
+    echo $file
+  fi
+  if [ -f $file ] ; then
+   file=$INDIR/${simorig}_SE_${years}_1M_histmth.nc
+   echo $file
    echo FILE $file
    cd $WRK
    dirout=$MainDIR/CMOR/${sim}_${years}/$cas
-#   sim=`echo $years | sed -e 's:_[0-9][0-9][0-9][0-9]_[0-9][0-9][0-9][0-9]::'`
    echo $sim $years $dirout
 
Index: /BOL/Multi_atlas/html_accueil.sh
===================================================================
--- /BOL/Multi_atlas/html_accueil.sh	(revision 3881)
+++ /BOL/Multi_atlas/html_accueil.sh	(revision 3882)
@@ -6,10 +6,10 @@
 hostname=`hostname`
 if [ ${hostname:0:5} = cicla ] ; then
-DODSDIR=/modfs/ipslfs/dods
+DODSDIR=/thredds/ipsl
 HTML=http://vesg.ipsl.upmc.fr/thredds/fileServer/IPSLFS/$login/lmdz/MultiSimu/$comp
 machine=ciclad
 fi
 if [ ${hostname:0:5} = camel ] ; then
-DODSDIR=/modfs/ipslfs/dods
+DODSDIR=/thredds/ipsl
 fi
 if [ ${hostname:0:5} = irene ] ; then
@@ -36,4 +36,4 @@
 
 # ATTENTION A MODIFIER POUR D AUTRES MACHINE
-echo $compf | sed -e 's:/modfs/ipslfs/dods/:http\://vesg.ipsl.upmc.fr/thredds/fileServer/IPSLFS/:'
+echo $compf | sed -e 's:/thredds/ipsl/:http\://vesg.ipsl.upmc.fr/thredds/fileServer/IPSLFS/:'
 
Index: /BOL/Multi_atlas/html_all.sh
===================================================================
--- /BOL/Multi_atlas/html_all.sh	(revision 3881)
+++ /BOL/Multi_atlas/html_all.sh	(revision 3882)
@@ -5,10 +5,10 @@
 hostname=`hostname`
 if [ ${hostname:0:5} = cicla ] ; then
-DODSDIR=/prodigfs/ipslfs/dods
+DODSDIR=/thredds/ipsl
 HTML00=http://vesg.ipsl.upmc.fr/thredds/fileServer/IPSLFS/$login
 machine=ciclad
 fi
 if [ ${hostname:0:5} = camel ] ; then
-DODSDIR=/prodigfs/ipslfs/dods
+DODSDIR=/thredds/ipsl
 fi
 if [ ${hostname:0:5} = irene ] ; then
@@ -26,8 +26,8 @@
 
 i=1
-for f in /prodigfs/ipslfs/dods/fabric/lmdz/MultiSimu/*/entete.html ; do
-    sim=`echo $f | cut -d/ -f8`
+for f in /thredds/ipsl/fabric/lmdz/MultiSimu/*/entete.html ; do
+    sim=`echo $f | cut -d/ -f7`
 # A REFAIRE
-echo "<TD ALIGN=LEFT><A HREF=`echo $f | sed -e 's:/prodigfs/ipslfs/dods/:http\://vesg.ipsl.upmc.fr/thredds/fileServer/IPSLFS/:'`> $sim </A> </TD>"
+echo "<TD ALIGN=LEFT><A HREF=`echo $f | sed -e 's:/thredds/ipsl/:http\://vesg.ipsl.upmc.fr/thredds/fileServer/IPSLFS/:'`> $sim </A> </TD>"
 
 if [ $i = 8 ] ; then
Index: /BOL/Multi_atlas/html_axe1.sh
===================================================================
--- /BOL/Multi_atlas/html_axe1.sh	(revision 3881)
+++ /BOL/Multi_atlas/html_axe1.sh	(revision 3882)
@@ -8,10 +8,10 @@
 hostname=`hostname`
 if [ ${hostname:0:5} = cicla ] ; then
-DODSDIR=/modfs/ipslfs/dods
+DODSDIR=/thredds/ipsl
 HTML00=http://vesg.ipsl.upmc.fr/thredds/fileServer/IPSLFS/$login
 machine=ciclad
 fi
 if [ ${hostname:0:5} = camel ] ; then
-DODSDIR=/modfs/ipslfs/dods
+DODSDIR=/thredds/ipsl
 fi
 if [ ${hostname:0:5} = irene ] ; then
@@ -99,4 +99,4 @@
 
 # A REFAIRE
-echo $compf | sed -e 's:/modfs/ipslfs/dods/:http\://vesg.ipsl.upmc.fr/thredds/fileServer/IPSLFS/:'
+echo $compf | sed -e 's:/thredds/ipsl/:http\://vesg.ipsl.upmc.fr/thredds/fileServer/IPSLFS/:'
 
Index: /BOL/Multi_atlas/html_axe2.sh
===================================================================
--- /BOL/Multi_atlas/html_axe2.sh	(revision 3881)
+++ /BOL/Multi_atlas/html_axe2.sh	(revision 3882)
@@ -7,10 +7,10 @@
 hostname=`hostname`
 if [ ${hostname:0:5} = cicla ] ; then
-DODSDIR=/modfs/ipslfs/dods
+DODSDIR=/thredds/ipsl
 HTML00=http://vesg.ipsl.upmc.fr/thredds/fileServer/IPSLFS/$login
 machine=ciclad
 fi
 if [ ${hostname:0:5} = camel ] ; then
-DODSDIR=/modfs/ipslfs/dods
+DODSDIR=/thredds/ipsl
 fi
 if [ ${hostname:0:5} = irene ] ; then
@@ -59,3 +59,3 @@
 
 # A REFAIRE
-echo $compf | sed -e 's:/modfs/ipslfs/dods/:http\://vesg.ipsl.upmc.fr/thredds/fileServer/IPSLFS/:'
+echo $compf | sed -e 's:/thredds/ipsl/:http\://vesg.ipsl.upmc.fr/thredds/fileServer/IPSLFS/:'
Index: /BOL/Multi_atlas/html_axe3.sh
===================================================================
--- /BOL/Multi_atlas/html_axe3.sh	(revision 3881)
+++ /BOL/Multi_atlas/html_axe3.sh	(revision 3882)
@@ -8,10 +8,10 @@
 hostname=`hostname`
 if [ ${hostname:0:5} = cicla ] ; then
-DODSDIR=/modfs/ipslfs/dods
+DODSDIR=/thredds/ipsl
 HTML00=http://vesg.ipsl.upmc.fr/thredds/fileServer/IPSLFS/$login
 machine=ciclad
 fi
 if [ ${hostname:0:5} = camel ] ; then
-DODSDIR=/modfs/ipslfs/dods
+DODSDIR=/thredds/ipsl
 fi
 if [ ${hostname:0:5} = irene ] ; then
@@ -128,3 +128,3 @@
 $local/concat_html.sh $COMP_D/REG "Regimes dynamiques tropicaux" $concatarg 3 >> $COMP_D/REG/index.html
 
-echo $compf | sed -e 's:/modfs/ipslfs/dods/:http\://vesg.ipsl.upmc.fr/thredds/fileServer/IPSLFS/:'
+echo $compf | sed -e 's:/thredds/ipsl/:http\://vesg.ipsl.upmc.fr/thredds/fileServer/IPSLFS/:'
Index: /BOL/Multi_atlas/html_axe4.sh
===================================================================
--- /BOL/Multi_atlas/html_axe4.sh	(revision 3881)
+++ /BOL/Multi_atlas/html_axe4.sh	(revision 3882)
@@ -7,10 +7,10 @@
 hostname=`hostname`
 if [ ${hostname:0:5} = cicla ] ; then
-DODSDIR=/modfs/ipslfs/dods
+DODSDIR=/thredds/ipsl
 HTML00=http://vesg.ipsl.upmc.fr/thredds/fileServer/IPSLFS/$login
 machine=ciclad
 fi
 if [ ${hostname:0:5} = camel ] ; then
-DODSDIR=/modfs/ipslfs/dods
+DODSDIR=/thredds/ipsl
 fi
 if [ ${hostname:0:5} = irene ] ; then
@@ -95,4 +95,4 @@
 
 
-echo $compf | sed -e 's:/modfs/ipslfs/dods/:http\://vesg.ipsl.upmc.fr/thredds/fileServer/IPSLFS/:'
+echo $compf | sed -e 's:/thredds/ipsl/:http\://vesg.ipsl.upmc.fr/thredds/fileServer/IPSLFS/:'
 
Index: /BOL/Multi_atlas/html_axe5.sh
===================================================================
--- /BOL/Multi_atlas/html_axe5.sh	(revision 3881)
+++ /BOL/Multi_atlas/html_axe5.sh	(revision 3882)
@@ -7,10 +7,10 @@
 hostname=`hostname`
 if [ ${hostname:0:5} = cicla ] ; then
-DODSDIR=/modfs/ipslfs/dods
+DODSDIR=/thredds/ipsl
 HTML00=http://vesg.ipsl.upmc.fr/thredds/fileServer/IPSLFS/$login
 machine=ciclad
 fi
 if [ ${hostname:0:5} = camel ] ; then
-DODSDIR=/modfs/ipslfs/dods
+DODSDIR=/thredds/ipsl
 fi
 if [ ${hostname:0:5} = irene ] ; then
@@ -46,4 +46,4 @@
 eod
 
-echo $compf | sed -e 's:/modfs/ipslfs/dods/:http\://vesg.ipsl.upmc.fr/thredds/fileServer/IPSLFS/:'
+echo $compf | sed -e 's:/thredds/ipsl/:http\://vesg.ipsl.upmc.fr/thredds/fileServer/IPSLFS/:'
 
Index: /BOL/Multi_atlas/html_axe6.sh
===================================================================
--- /BOL/Multi_atlas/html_axe6.sh	(revision 3881)
+++ /BOL/Multi_atlas/html_axe6.sh	(revision 3882)
@@ -7,10 +7,10 @@
 hostname=`hostname`
 if [ ${hostname:0:5} = cicla ] ; then
-DODSDIR=/modfs/ipslfs/dods
+DODSDIR=/thredds/ipsl
 HTML00=http://vesg.ipsl.upmc.fr/thredds/fileServer/IPSLFS/$login
 machine=ciclad
 fi
 if [ ${hostname:0:5} = camel ] ; then
-DODSDIR=/modfs/ipslfs/dods
+DODSDIR=/thredds/ipsl
 fi
 if [ ${hostname:0:5} = irene ] ; then
@@ -45,3 +45,3 @@
 
 
-echo $compf | sed -e 's:/modfs/ipslfs/dods/:http\://vesg.ipsl.upmc.fr/thredds/fileServer/IPSLFS/:'
+echo $compf | sed -e 's:/thredds/ipsl/:http\://vesg.ipsl.upmc.fr/thredds/fileServer/IPSLFS/:'
Index: /BOL/Multi_atlas/html_axe7.sh
===================================================================
--- /BOL/Multi_atlas/html_axe7.sh	(revision 3881)
+++ /BOL/Multi_atlas/html_axe7.sh	(revision 3882)
@@ -8,10 +8,10 @@
 hostname=`hostname`
 if [ ${hostname:0:5} = cicla ] ; then
-DODSDIR=/modfs/ipslfs/dods
+DODSDIR=/thredds/ipsl
 HTML00=http://vesg.ipsl.upmc.fr/thredds/fileServer/IPSLFS/$login
 machine=ciclad
 fi
 if [ ${hostname:0:5} = camel ] ; then
-DODSDIR=/modfs/ipslfs/dods
+DODSDIR=/thredds/ipsl
 fi
 if [ ${hostname:0:5} = irene ] ; then
@@ -128,3 +128,3 @@
 
 
-echo $compf | sed -e 's:/modfs/ipslfs/dods/:http\://vesg.ipsl.upmc.fr/thredds/fileServer/IPSLFS/:'
+echo $compf | sed -e 's:/thredds/ipsl/:http\://vesg.ipsl.upmc.fr/thredds/fileServer/IPSLFS/:'
Index: /BOL/Multi_atlas/install_multi_atlas.sh
===================================================================
--- /BOL/Multi_atlas/install_multi_atlas.sh	(revision 3881)
+++ /BOL/Multi_atlas/install_multi_atlas.sh	(revision 3882)
@@ -29,5 +29,5 @@
 if [ ${hostname:0:5} = cicla ] ; then
 # chemin vers le rep dods de base
-DODSDIR=/modfs/ipslfs/dods
+DODSDIR=/thredds/ipsl
 # Rep ou sont stockes les multiatlas
 MULTIDIR=$DODSDIR/$login/lmdz/MultiSimu
@@ -58,5 +58,5 @@
 # CLIMSERV
 if [ ${hostname:0:5} = camel ] ; then
-DODSDIR=/modfs/ipslfs/dods
+DODSDIR=/thredds/ipsl
 cat <<eod > entete.sh
 #PBS -N atlas
@@ -142,12 +142,12 @@
 echo -e "${bleufonce}"To create your multi-atlas you needs :
 echo 1.  to create your multiatlas directory "example Multi01" :
-echo     mkdir -p /modfs/ipslfs/dods/$login/lmdz/MultiSimu/Multi01
+echo     mkdir -p $DODSdir/$login/lmdz/MultiSimu/Multi01
 echo  
 echo 2.  to define some characeristics of your multi-atlas "names, dates, description of simulations and atlas variables" :
-echo     cp Utils/def.txt  Utils/atlas-def /modfs/ipslfs/dods/$login/lmdz/MultiSimu/Multi01/.
+echo     cp Utils/def.txt  Utils/atlas-def ${DODSdir}/$login/lmdz/MultiSimu/Multi01/.
 echo     define "names, date, description" of simulations in file :
-echo     /modfs/ipslfs/dods/$login/lmdz/MultiSimu/Multi01/def.txt
+echo     ${DODSdir}/$login/lmdz/MultiSimu/Multi01/def.txt
 echo     define atlas variables in file :
-echo     /modfs/ipslfs/dods/$login/lmdz/MultiSimu/Multi01/atlas-def
+echo     $DODSdir/$login/lmdz/MultiSimu/Multi01/atlas-def
 echo
 echo 3.   Add the link to the simulation outputs in your file : $local/runs.txt
Index: /BOL/Multi_atlas/make_html_libigcm.sh
===================================================================
--- /BOL/Multi_atlas/make_html_libigcm.sh	(revision 3881)
+++ /BOL/Multi_atlas/make_html_libigcm.sh	(revision 3882)
@@ -55,10 +55,10 @@
 hostname=`hostname`
 if [ ${hostname:0:5} = cicla ] ; then
-DODSDIR=/modfs/ipslfs/dods
+DODSDIR=/thredds/ipsl
 HTML=http://vesg.ipsl.upmc.fr/thredds/fileServer/IPSLFS/$login/lmdz/MultiSimu/$comp
 machine=ciclad
 fi
 if [ ${hostname:0:5} = camel ] ; then
-DODSDIR=/modfs/ipslfs/dods
+DODSDIR=/thredds/ipsl
 fi
 if [ ${hostname:0:5} = irene ] ; then
@@ -88,5 +88,5 @@
 STORAGE=$CICLAD
 ROOTWEBatlas=http://vesg.ipsl.upmc.fr/thredds/fileServer/IPSLFS/$login/lmdz/STORE/$EXPNAME
-MULTIDIR=/modfs/ipslfs/dods/$login/lmdz/MultiSimu
+MULTIDIR=$DODSDIR/$login/lmdz/MultiSimu
 COMP_D=$MULTIDIR/$comp
 DEF_FILE=$COMP_D/def.txt
@@ -210,5 +210,5 @@
                  fi
 # ATTENTION A REFAIRE EN FONCTION DE LA MACHINE
-                 atlas_html=`echo $atlasf | sed -e 's:/modfs/ipslfs/dods/:http\://vesg.ipsl.upmc.fr/thredds/fileServer/IPSLFS/:'`
+                 atlas_html=`echo $atlasf | sed -e 's:/thredds/ipsl/:http\://vesg.ipsl.upmc.fr/thredds/fileServer/IPSLFS/:'`
                  echo atlas_html $atlas_html
                  echo atlasf $atlasf
Index: /BOL/Multi_atlas/multi_ZONE.sh
===================================================================
--- /BOL/Multi_atlas/multi_ZONE.sh	(revision 3881)
+++ /BOL/Multi_atlas/multi_ZONE.sh	(revision 3882)
@@ -14,8 +14,8 @@
 hostname=`hostname`
 if [ ${hostname:0:5} = cicla ] ; then
-DODSDIR=/modfs/ipslfs/dods
+DODSDIR=/thredds/ipsl
 fi
 if [ ${hostname:0:5} = camel ] ; then
-DODSDIR=/modfs/ipslfs/dods
+DODSDIR=/thredds/ipsl
 fi
 if [ ${hostname:0:5} = irene ] ; then
@@ -28,5 +28,5 @@
 MAINDIR=$DODSDIR/$login/lmdz
 
-runstxt=/home/fabric/LMDZ/MultiSimu/runs.txt
+runstxt=`pwd`/runs.txt
 
 while test -n "${1}"; do
@@ -56,14 +56,14 @@
 echo $COMP_D
 
-#sims="OBS " ; for ss in `awk ' {print $1"_"$2 } ' $DEF_FILE` ; do sims="$sims $ss" ; done
-#echo sims $sims
-#exit
 listsims=""  ; for s  in `awk ' {print $1} ' $DEF_FILE`          ; do listsims="$listsims $s"    ; done
 echo listsims $listsims
+
 sims="OBS "
+
+echo listsims= $listsims
+
 for s in $listsims ; do
 simdir=`grep -w "^$s "  $runstxt | awk ' { print $2 } '`
 ss=`basename $simdir `
-#year=`grep -w "^$s " $DEF_FILE | awk ' { print $2 } '`
 year=`grep -w "^$s" $DEF_FILE | awk ' { print $2 } '`
 sims="$sims ${s}_$year"
@@ -76,6 +76,4 @@
 #vars="pr prw rstt rlut rtt crelt crest crett hfns hfls tas sst tauu tauv psl zg500 rsts rsut rlutcs albs albt cress crels crets rts rah rahcs rahcre rlah rlahcs rlahcre rsah rsahcs rsahcre hurs hfss rldscs rlds rlus rsdscs rsds rsus rsuscs rsutcs prw"
 vars="pr prw rstt rlut rtt crelt crest crett hfns hfls tas sst tauu tauv psl zg500 rsts rsut rlutcs albs albt cress crels crets rts rah rahcs rahcre rlah rlahcs rlahcre rsah rsahcs rsahcre hurs hfss rldscs rlds rlus rsdscs rsds rsus rsuscs rsutcs prw rttcs rsttcs cllcalipso clmcalipso clhcalipso cll clm clh"
-#vars=$4
-#vars="eva"
 echo $vars
 
@@ -97,5 +95,4 @@
 
 
-#line=`grep  "$var," $local/description.zon`
 line=`grep  "$var," $local/description${SEAS}.zon`
 if [ "$line" = "" ] ; then echo $var non prevue dans description ; exit ; fi
@@ -118,5 +115,9 @@
 echo OK0 $sims
 for sim in $sims ; do
-   if [ $sim = OBS ] ; then MAINDIR=$DODSDIR/fabric/lmdz ; fi
+   MAINDIR=$DODSDIR/$login/lmdz
+   if [ "$sim" = "OBS" ] ; then 
+     MAINDIR=$DODSDIR/fabric/lmdz ; 
+   fi
+   echo sim is= $sim
    ZONDIR=$MAINDIR/$GR/$SEAS/$sim/$ZONE
    echo $ZONDIR
@@ -127,11 +128,4 @@
 done
 
-
-    #yaxis  tick major 5
-    #yaxis  tick minor 1
-
-#if [ $nsims = 2 ] ; then
-#    view="0.15, 0.15, 1, 0.6"
-#    legend="0.15,0.7"
 if [ $var == "prl" ] || [ $var == "prc" ] ; then
     legend="0.72,0.7"
Index: /BOL/Multi_atlas/season.sh
===================================================================
--- /BOL/Multi_atlas/season.sh	(revision 3881)
+++ /BOL/Multi_atlas/season.sh	(revision 3882)
@@ -12,8 +12,8 @@
 hostname=`hostname`
 if [ ${hostname:0:5} = cicla ] ; then
-DODSDIR=/modfs/ipslfs/dods
+DODSDIR=/thredds/ipsl
 fi
 if [ ${hostname:0:5} = camel ] ; then
-DODSDIR=/modfs/ipslfs/dods
+DODSDIR=/thredds/ipsl
 fi
 if [ ${hostname:0:5} = irene ] ; then
@@ -49,5 +49,5 @@
      "-s") listesim=`echo $2 | sed -e 's/,/ /g'` ; shift ; shift ;;
      "-f") force_create=1 ; shift ;;
-     "-comp") COMP_D=/modfs/ipslfs/dods/fabric/lmdz/MultiSimu/$2 ; shift ; shift ;;
+     "-comp") COMP_D=/thredds/ipsl/fabric/lmdz/MultiSimu/$2 ; shift ; shift ;;
      "-seas") listeseas=$2 ; shift ; shift ;;
      *) ./cmor.sh -h ; shift ; exit ;;