Index: /BOL/Multi_atlas/Utils/atlas0.sh
===================================================================
--- /BOL/Multi_atlas/Utils/atlas0.sh	(revision 3884)
+++ /BOL/Multi_atlas/Utils/atlas0.sh	(revision 3885)
@@ -45,5 +45,5 @@
 elif [ $# = 0 ] ; then
    sim=$RUN
-   ref=OBS
+   ref=$REF
    seas=$SEASON
    proj=$PROJ
@@ -109,5 +109,5 @@
 
 
-npass=5
+npass=1
 ipass=1
 
@@ -118,5 +118,5 @@
    echo passage $ipass >> atlas.sh.log
    html=index_example_"$seas"_"$sim".html
-   htmlopt=index_${proj}_"$seas"_"$sim".html
+   htmlopt=index_"${proj}"_"$seas"_"$sim".html
    rm -f $html
 
@@ -129,25 +129,29 @@
    fi
 
-   echo python $local/$pyatlas -v $vars -s `basename $simdir`_$years -t $ref -p $seas --root $INDIR
-   python $local/$pyatlas -v $vars -s `basename $simdir`_$years -t $ref -p $seas --root $INDIR
+   #echo python $local/$pyatlas -v $vars -s `basename $simdir`_$years -t $ref -p $seas --root $INDIR
+   #python $local/$pyatlas -v $vars -s `basename $simdir`_$years -t $ref -p $seas --root $INDIR
+   echo python $local/$pyatlas -v $vars -s `basename $simdir`_$years -t $ref -p $seas
+   python $local/$pyatlas -v $vars -s `basename $simdir`_$years -t $ref -p $seas
 
-   if [ ! -f "$html"  -o "`wc -l $html | awk ' { print $1 } '`" = "0" ] ; then
+   #if [ ! -f "$html"  -o "`wc -l $html | awk ' { print $1 } '`" = "0" ] ; then
+   if [ ! -f "$htmlopt"  -o "`wc -l $htmlopt | awk ' { print $1 } '`" = "0" ] ; then
       echo ECHEC ATLAS : $html inexistant ou vide | tee >>  atlas.sh.log
       echo ECHEC ATLAS : $html inexistant ou vide
    else
-      echo cp -f $html tmp$$.$passage
-      cp -f $html tmp$$.$passage
+      #echo cp -f $html tmp$$.$passage
+      #cp -f $html tmp$$.$passage
       pwd
-      echo tmp$$.$passage
-      echo LS  LS
-      ls -lrt | tail
+      #echo tmp$$.$passage
+      #echo LS  LS
+      #ls -lrt | tail
 # A ADAPTER en fonction de la machine
-      sed -e "s:/modfs/ipslfs/dods/:/thredds/fileServer/IPSLFS/:g" tmp$$.$passage >| $htmlopt
+      #sed -e "s:/modfs/ipslfs/dods/:/thredds/fileServer/IPSLFS/:g" tmp$$.$passage >| $htmlopt
       \cp -f $htmlopt $OUT_D/
-      PathHtml=`echo $OUT_D/$htmlopt | sed -e 's:/modfs/ipslfs/dods/:http\://vesg.ipsl.upmc.fr/thredds/fileServer/IPSLFS/:'`
+      sed -i -e "s:thredds\/ipsl:thredds\/fileServer\/IPSLFS:g" $OUT_D/$htmlopt
+      #PathHtml=`echo $OUT_D/$htmlopt | sed -e 's:/modfs/ipslfs/dods/:http\://vesg.ipsl.upmc.fr/thredds/fileServer/IPSLFS/:'`
       echo NOUVEL ATLAS DISPONIBLE SUR $PathHtml | tee >>  atlas.sh.log
       echo NOUVEL ATLAS DISPONIBLE SUR $PathHtml
-      echo $keys_strgv >> $OUT_D/atlas_OK
-      echo ${sim}+${seas}+${proj}+$vars >> $OUT_D/atlas_OK
+      #echo $keys_strgv >> $OUT_D/atlas_OK
+      #echo ${sim}+${seas}+${proj}+$vars >> $OUT_D/atlas_OK
    fi
    (( ipass = $ipass + 1 ))
Index: /BOL/Multi_atlas/Utils/multi.sh
===================================================================
--- /BOL/Multi_atlas/Utils/multi.sh	(revision 3884)
+++ /BOL/Multi_atlas/Utils/multi.sh	(revision 3885)
@@ -30,5 +30,8 @@
 mjo=0
 river=0
-
+dataref=1
+
+ref=OBS
+echo $ref
 # ./job_multi.sh -1D 0 -get 0 -atlas 0 -pcmdi 0 -tuning 0 -lma 0 -trmm 0
 runstxt=$local/runs.txt
@@ -57,4 +60,5 @@
       -mjo) mjo=$2 ; shift ;; 
       -river) river=$2 ; shift ;;
+      -dataref) dataref=$2 ; shift ;;
       *) comp=$1 ;;
    esac
@@ -123,5 +127,20 @@
 echo listrune= $listrune 
 ls -lrt $MAIN_SE/ORIG
-listsimss="" ; for ss in `awk ' {print $1"_"$2 } ' $DEF_FILE`    ; do listsimss="$listsimss $ss" ; done
+#listsimss="" ; for ss in `awk ' {print $1"_"$2 } ' $DEF_FILE`    ; do listsimss="$listsimss $ss" ; done
+
+ns=0
+listsimss="" ; 
+for ss in `awk ' {print $1"_"$2 } ' $DEF_FILE`    ; do  
+if [ $dataref = 0 ] ; then
+   if [ ${ns} = 0 ] ; then
+      ref=$ss
+      echo ref=$ref
+   fi  
+fi
+let "ns = ${ns} + 1"
+listsimss="$listsimss $ss" ; 
+done
+echo ref=$ref
+
 listsimse="" ; for se in `awk ' {print $1"_SE_"$2 } ' $DEF_FILE` ; do listsimse="$listsimse $se" ; done
 echo listsims $listsims
@@ -199,21 +218,25 @@
       atlas=${sim}+${seas}+${proj}+$vars
       echo AAAAAAAAAAAAAAAAAAAAAAAA $atlas
-      grep $atlas $COMP_D/ATLAS/atlas_OK
+      #grep $atlas $COMP_D/ATLAS/atlas_OK
       echo BBBBBB
-      if [ "`grep $atlas $COMP_D/ATLAS/atlas_OK`" = "" ] ; then
+      #if [ "`grep $atlas $COMP_D/ATLAS/atlas_OK`" = "" ] ; then
          cd $local/atlas ; pwd ; ls -l atlas.sh
          varg=`echo $vars | sed -e 's/,/+/g'`
          echo Atlas $atlas a creer
          if [ $qsub = 0 ] ; then
-            ./atlas.sh RUN=$sim,SEASON=$seas,PROJ=$proj,OUTDIR=$COMP_D/ATLAS,REF=OBS,VARS="$varg",RUNSTXT=$runstxt
+            #./atlas.sh RUN=$sim,SEASON=$seas,PROJ=$proj,OUTDIR=$COMP_D/ATLAS,REF=OBS,VARS="$varg",RUNSTXT=$runstxt
+            ./atlas.sh RUN=$sim,SEASON=$seas,PROJ=$proj,OUTDIR=$COMP_D/ATLAS,REF=$ref,VARS="$varg",RUNSTXT=$runstxt
          else
-            $submit -v RUN=$sim,SEASON=$seas,PROJ=$proj,OUTDIR=$COMP_D/ATLAS,REF=OBS,VARS="$varg",RUNSTXT=$runstxt atlas.sh
+            #$submit -v RUN=$sim,SEASON=$seas,PROJ=$proj,OUTDIR=$COMP_D/ATLAS,REF=OBS,VARS="$varg",RUNSTXT=$runstxt atlas.sh
+            $submit -v RUN=$sim,SEASON=$seas,PROJ=$proj,OUTDIR=$COMP_D/ATLAS,REF=$ref,VARS="$varg",RUNSTXT=$runstxt atlas.sh
          fi
-         echo $submit -v RUN=$sim,SEASON=$seas,PROJ=$proj,OUTDIR=$COMP_D/ATLAS,REF=OBS,VARS="$varg" atlas.sh >> out.com$$
-         echo $submit -v RUN=$sim,SEASON=$seas,PROJ=$proj,OUTDIR=$COMP_D/ATLAS,REF=OBS,VARS="$varg" atlas.sh
+         #echo $submit -v RUN=$sim,SEASON=$seas,PROJ=$proj,OUTDIR=$COMP_D/ATLAS,REF=OBS,VARS="$varg" atlas.sh >> out.com$$
+         echo $submit -v RUN=$sim,SEASON=$seas,PROJ=$proj,OUTDIR=$COMP_D/ATLAS,REF=$ref,VARS="$varg" atlas.sh >> out.com$$
+         #echo $submit -v RUN=$sim,SEASON=$seas,PROJ=$proj,OUTDIR=$COMP_D/ATLAS,REF=OBS,VARS="$varg" atlas.sh
+         echo $submit -v RUN=$sim,SEASON=$seas,PROJ=$proj,OUTDIR=$COMP_D/ATLAS,REF=$ref,VARS="$varg" atlas.sh
          (( count_atlas = $count_atlas + 1 ))
-      else
-           echo Atlas $atlas existant
-      fi
+      #else
+           #echo Atlas $atlas existant
+      #fi
       (( il = $il + 1 ))
    done
Index: /BOL/Multi_atlas/atlas/atlas_none.py
===================================================================
--- /BOL/Multi_atlas/atlas/atlas_none.py	(revision 3884)
+++ /BOL/Multi_atlas/atlas/atlas_none.py	(revision 3885)
@@ -107,4 +107,7 @@
        simu_pres = svsg(opts.simulation,'pres',opts.season,opts.grid)
        simu = ml2pl(simu,simu_pres)
+       if (ref != 'OBS' ) : 
+           reff_pres = svsg(opts.reference,'pres',opts.season,opts.grid)
+           reff = ml2pl(reff,reff_pres)
        simu = zonmean(simu)
        reff = zonmean(reff)
@@ -265,5 +268,5 @@
 index += trailer()
 #out="index_example.html"
-out="index_example_"+opts.season+"_"+opts.simulation+".html"
+out="index_"+opts.region+"_"+opts.season+"_"+opts.simulation+".html"
 with open(out,"w") as filout : filout.write(index)
 #